searchNodes=[{"doc":"Nerves.Runtime contains functions useful for almost all Nerves-based devices.","ref":"Nerves.Runtime.html","title":"Nerves.Runtime","type":"module"},{"doc":"Run system command and log output into logger. NOTE: Unlike System.cmd/3, this does not raise if the executable isn&#39;t found","ref":"Nerves.Runtime.html#cmd/3","title":"Nerves.Runtime.cmd/3","type":"function"},{"doc":"Halt the device (meaning hang, not power off, nor reboot). Note: this is different than :erlang.halt(), which exits BEAM, and may end up rebooting the device if erlinit.config settings allow reboot on exit.","ref":"Nerves.Runtime.html#halt/0","title":"Nerves.Runtime.halt/0","type":"function"},{"doc":"Power off the device. This calls :init.stop/0 internally. If :init.stop/0 takes longer than the erlinit.config&#39;s --graceful-powerdown setting (likely 10 seconds) then the system will be hard rebooted.","ref":"Nerves.Runtime.html#poweroff/0","title":"Nerves.Runtime.poweroff/0","type":"function"},{"doc":"Reboot the device and gracefully shutdown the Erlang VM. This calls :init.stop/0 internally. If :init.stop/0 takes longer than the erlinit.config&#39;s --graceful-powerdown setting (likely 10 seconds) then the system will be hard rebooted.","ref":"Nerves.Runtime.html#reboot/0","title":"Nerves.Runtime.reboot/0","type":"function"},{"doc":"Revert the device to running the previous firmware. This requires a specially constructed fw file.","ref":"Nerves.Runtime.html#revert/1","title":"Nerves.Runtime.revert/1","type":"function"},{"doc":"Return the device&#39;s serial number Serial number storage is device-specific and configurable. Serial numbers can be programmed in one-time programmable locations like in CPU ROM or cryptographic elements. They can also be in rewritable locations like a U-Boot environment block. Nerves uses the boardid by default (set :boardid_path key in the application environment to another program to override). Boardid uses the /etc/boardid.config file to determine how to read the serial number. Official Nerves systems provide reasonable default mechanisms for getting started. Override this file in your application&#39;s rootfs_overlay to customize it. This function never raises. If a serial number isn&#39;t available for any reason, it will return a serial number of &quot;unconfigured&quot;.","ref":"Nerves.Runtime.html#serial_number/0","title":"Nerves.Runtime.serial_number/0","type":"function"},{"doc":"Return whether the application was built for either the host or the target","ref":"Nerves.Runtime.html#target/0","title":"Nerves.Runtime.target/0","type":"function"},{"doc":"Options for Nerves.Runtime.revert/1. :reboot - Call Nerves.Runtime.reboot/0 after reverting (defaults to true)","ref":"Nerves.Runtime.html#t:revert_options/0","title":"Nerves.Runtime.revert_options/0","type":"type"},{"doc":"GenServer that handles device initialization. Initialization currently consists of: Mounting the application partition If the application partition can&#39;t be mounted, format it, and then mount it. Device initialization is usually a first boot only operation. It&#39;s possible that device filesystems get corrupt enough to cause them to be reinitialized. Since corruption should be rare, Nerves systems create firmware images without formatting the application partition. This has the benefit of exercising the corruption repair code. It&#39;s also required since some filesystem types can only be formatted on device. Long format times can be problematic in manufacturing. If this is an issue, see if you can use F2FS since it formats much faster than ext4. Some devices have also had stalls when formatting while waiting for enough entropy to generate a UUID. Look into hardcoding UUIDs or enabling a hw random number generator to increase entropy.","ref":"Nerves.Runtime.Init.html","title":"Nerves.Runtime.Init","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Nerves.Runtime.Init.html#child_spec/1","title":"Nerves.Runtime.Init.child_spec/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Init.html#init_application_partition/0","title":"Nerves.Runtime.Init.init_application_partition/0","type":"function"},{"doc":"","ref":"Nerves.Runtime.Init.html#mounted_state/1","title":"Nerves.Runtime.Init.mounted_state/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Init.html#start_link/1","title":"Nerves.Runtime.Init.start_link/1","type":"function"},{"doc":"Key Value storage for firmware variables provided by fwup. KV provides functionality to read and modify firmware metadata set by fwup. The firmware metadata contains information such as the active firmware slot, where the application data partition is located, etc. The firmware metadata store is a simple key-value store where both keys and values are stored as strings. The firmware metadata is stored in the U-boot environment block stored at the beginning of the disk outside of actual partitions. It is not stored redundantly, and it can be susceptible to corruption in case of power failure during writes. For this reason, it is recommended to use the firmware metadata with caution. The access patterns in this module lower the risk of corruption, and risk can be lowered further by storing as little data as possible in the firmware metadata. UBootEnv can alternatively be used for more direct access to the firmware metadata. However, since KV utilizes caching of the firmware metadata, you should use either KV or UBootEnv, not both. Examples Getting all firmware metadata: iex&gt; Nerves.Runtime.KV.get_all() %{ &quot;a.nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot;, &quot;a.nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot;, &quot;a.nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot;, &quot;a.nerves_fw_architecture&quot; =&gt; &quot;arm&quot;, &quot;a.nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot;, &quot;a.nerves_fw_description&quot; =&gt; &quot;&quot;, &quot;a.nerves_fw_misc&quot; =&gt; &quot;&quot;, &quot;a.nerves_fw_platform&quot; =&gt; &quot;rpi0&quot;, &quot;a.nerves_fw_product&quot; =&gt; &quot;test_app&quot;, &quot;a.nerves_fw_uuid&quot; =&gt; &quot;d9492bdb-94de-5288-425e-2de6928ef99c&quot;, &quot;a.nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot;, &quot;a.nerves_fw_version&quot; =&gt; &quot;0.1.0&quot;, &quot;b.nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot;, &quot;b.nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot;, &quot;b.nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot;, &quot;b.nerves_fw_architecture&quot; =&gt; &quot;arm&quot;, &quot;b.nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot;, &quot;b.nerves_fw_description&quot; =&gt; &quot;&quot;, &quot;b.nerves_fw_misc&quot; =&gt; &quot;&quot;, &quot;b.nerves_fw_platform&quot; =&gt; &quot;rpi0&quot;, &quot;b.nerves_fw_product&quot; =&gt; &quot;test_app&quot;, &quot;b.nerves_fw_uuid&quot; =&gt; &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot;, &quot;b.nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot;, &quot;b.nerves_fw_version&quot; =&gt; &quot;0.1.1&quot;, &quot;nerves_fw_active&quot; =&gt; &quot;b&quot;, &quot;nerves_fw_devpath&quot; =&gt; &quot;/dev/mmcblk0&quot;, &quot;nerves_serial_number&quot; =&gt; &quot;&quot; } Parts of the firmware metadata are global, while others pertain to a specific firmware slot. This is indicated by the key - data which describes firmware of a specific slot have keys prefixed with the name of the firmware slot. In the above example, &quot;nerves_fw_active&quot; and &quot;nerves_serial_number&quot; are global, while &quot;a.nerves_fw_version&quot; and &quot;b.nerves_fw_version&quot; apply to the &quot;a&quot; and &quot;b&quot; firmware slots, respectively. It is also possible to get firmware metadata that only pertains to the currently active firmware slot: iex&gt; Nerves.Runtime.KV.get_all_active() %{ &quot;nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot;, &quot;nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot;, &quot;nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot;, &quot;nerves_fw_architecture&quot; =&gt; &quot;arm&quot;, &quot;nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot;, &quot;nerves_fw_description&quot; =&gt; &quot;&quot;, &quot;nerves_fw_misc&quot; =&gt; &quot;&quot;, &quot;nerves_fw_platform&quot; =&gt; &quot;rpi0&quot;, &quot;nerves_fw_product&quot; =&gt; &quot;test_app&quot;, &quot;nerves_fw_uuid&quot; =&gt; &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot;, &quot;nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot;, &quot;nerves_fw_version&quot; =&gt; &quot;0.1.1&quot; } Note that get_all_active/0 strips out the a. and b. prefixes. Further, the two functions get/1 and get_active/1 allow you to get a specific key from the firmware metadata. get/1 requires specifying the entire key name, while get_active/1 will prepend the slot prefix for you: iex&gt; Nerves.Runtime.KV.get(&quot;nerves_fw_active&quot;) &quot;b&quot; iex&gt; Nerves.Runtime.KV.get(&quot;b.nerves_fw_uuid&quot;) &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; iex&gt; Nerves.Runtime.KV.get_active(&quot;nerves_fw_uuid&quot;) &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; Aside from reading values from the KV store, it is also possible to write new values to the firmware metadata. New values may either have unique keys, in which case they will be added to the firmware metadata, or re-use a key, in which case they will overwrite the current value with that key: iex&gt; :ok = Nerves.Runtime.KV.put(&quot;my_firmware_key&quot;, &quot;my_value&quot;) iex&gt; :ok = Nerves.Runtime.KV.put(&quot;nerves_serial_number&quot;, &quot;my_new_serial_number&quot;) iex&gt; Nerves.Runtime.KV.get(&quot;my_firmware_key&quot;) &quot;my_value&quot; iex&gt; Nerves.Runtime.KV.get(&quot;nerves_serial_number&quot;) &quot;my_new_serial_number&quot; It is possible to write a collection of values at once, in order to minimize number of writes: iex&gt; :ok = Nerves.Runtime.KV.put(%{&quot;one_key&quot; =&gt; &quot;one_val&quot;, &quot;two_key&quot; =&gt; &quot;two_val&quot;}) iex&gt; Nerves.Runtime.KV.get(&quot;one_key&quot;) &quot;one_val&quot; Lastly, put_active/1 and put_active/2 allow you to write firmware metadata to the currently active firmware slot without specifying the slot prefix yourself: iex&gt; :ok = Nerves.Runtime.KV.put_active(&quot;nerves_fw_misc&quot;, &quot;Nerves is awesome&quot;) iex&gt; Nerves.Runtime.KV.get_active(&quot;nerves_fw_misc&quot;) &quot;Nerves is awesome&quot;","ref":"Nerves.Runtime.KV.html","title":"Nerves.Runtime.KV","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Nerves.Runtime.KV.html#child_spec/1","title":"Nerves.Runtime.KV.child_spec/1","type":"function"},{"doc":"Get the key regardless of firmware slot","ref":"Nerves.Runtime.KV.html#get/1","title":"Nerves.Runtime.KV.get/1","type":"function"},{"doc":"Get the key for only the active firmware slot","ref":"Nerves.Runtime.KV.html#get_active/1","title":"Nerves.Runtime.KV.get_active/1","type":"function"},{"doc":"Get all keys regardless of firmware slot","ref":"Nerves.Runtime.KV.html#get_all/0","title":"Nerves.Runtime.KV.get_all/0","type":"function"},{"doc":"Get all key value pairs for only the active firmware slot","ref":"Nerves.Runtime.KV.html#get_all_active/0","title":"Nerves.Runtime.KV.get_all_active/0","type":"function"},{"doc":"","ref":"Nerves.Runtime.KV.html#c:init/1","title":"Nerves.Runtime.KV.init/1","type":"callback"},{"doc":"Write a collection of key-value pairs to the firmware metadata","ref":"Nerves.Runtime.KV.html#put/1","title":"Nerves.Runtime.KV.put/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.KV.html#c:put/1","title":"Nerves.Runtime.KV.put/1","type":"callback"},{"doc":"Write a key-value pair to the firmware metadata","ref":"Nerves.Runtime.KV.html#put/2","title":"Nerves.Runtime.KV.put/2","type":"function"},{"doc":"Write a collection of key-value pairs to the active firmware slot","ref":"Nerves.Runtime.KV.html#put_active/1","title":"Nerves.Runtime.KV.put_active/1","type":"function"},{"doc":"Write a key-value pair to the active firmware slot","ref":"Nerves.Runtime.KV.html#put_active/2","title":"Nerves.Runtime.KV.put_active/2","type":"function"},{"doc":"Start the KV store server","ref":"Nerves.Runtime.KV.html#start_link/1","title":"Nerves.Runtime.KV.start_link/1","type":"function"},{"doc":"Applications that depend on nerves_runtime for accessing provisioning information from the Nerves.Runtime.KV can mock the contents through the Application config. config :nerves_runtime, Nerves.Runtime.KV.Mock, %{&quot;key&quot; =&gt; &quot;value&quot;}","ref":"Nerves.Runtime.KV.Mock.html","title":"Nerves.Runtime.KV.Mock","type":"module"},{"doc":"","ref":"Nerves.Runtime.KV.Mock.html#init_state/1","title":"Nerves.Runtime.KV.Mock.init_state/1","type":"function"},{"doc":"GenServer that captures Linux uevent messages and passes them up to Elixir.","ref":"Nerves.Runtime.Kernel.UEvent.html","title":"Nerves.Runtime.Kernel.UEvent","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Nerves.Runtime.Kernel.UEvent.html#child_spec/1","title":"Nerves.Runtime.Kernel.UEvent.child_spec/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Kernel.UEvent.html#registry/4","title":"Nerves.Runtime.Kernel.UEvent.registry/4","type":"function"},{"doc":"","ref":"Nerves.Runtime.Kernel.UEvent.html#start_link/1","title":"Nerves.Runtime.Kernel.UEvent.start_link/1","type":"function"},{"doc":"Functions for parsing kmsg strings","ref":"Nerves.Runtime.Log.KmsgParser.html","title":"Nerves.Runtime.Log.KmsgParser","type":"module"},{"doc":"Parse out the kmsg facility, severity, and message (including the timestamp and host) from a kmsg-formatted string. See https://elixir.bootlin.com/linux/latest/source/Documentation/ABI/testing/dev-kmsg for full details. Most messages are of the form: priority,sequence,timestamp,flag;message priority is an integer that when broken apart gives you a facility and severity. sequence is a monotonically increasing counter timestamp is the time in microseconds flag is almost always - message is everything else This parser only supports the minimum kmsg reports. The spec above describes more functionality, but it appears to be uncommon and I haven&#39;t seen any examples yet in my testing.","ref":"Nerves.Runtime.Log.KmsgParser.html#parse/1","title":"Nerves.Runtime.Log.KmsgParser.parse/1","type":"function"},{"doc":"Collects operating system-level messages from /proc/kmsg, forwarding them to Logger with an appropriate level to match the syslog priority parsed out of the message.","ref":"Nerves.Runtime.Log.KmsgTailer.html","title":"Nerves.Runtime.Log.KmsgTailer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Nerves.Runtime.Log.KmsgTailer.html#child_spec/1","title":"Nerves.Runtime.Log.KmsgTailer.child_spec/1","type":"function"},{"doc":"Start the kmsg monitoring GenServer.","ref":"Nerves.Runtime.Log.KmsgTailer.html#start_link/1","title":"Nerves.Runtime.Log.KmsgTailer.start_link/1","type":"function"},{"doc":"Functions for parsing syslog strings","ref":"Nerves.Runtime.Log.SyslogParser.html","title":"Nerves.Runtime.Log.SyslogParser","type":"module"},{"doc":"Decode a syslog priority to facility and severity","ref":"Nerves.Runtime.Log.SyslogParser.html#decode_priority/1","title":"Nerves.Runtime.Log.SyslogParser.decode_priority/1","type":"function"},{"doc":"Parse out the syslog facility, severity, and message (including the timestamp and host) from a syslog-formatted string. The message is of the form: &lt;pri&gt;message pri is an integer that when broken apart gives you a facility and severity. message is everything else.","ref":"Nerves.Runtime.Log.SyslogParser.html#parse/1","title":"Nerves.Runtime.Log.SyslogParser.parse/1","type":"function"},{"doc":"Convert severity to an Elixir logger level","ref":"Nerves.Runtime.Log.SyslogParser.html#severity_to_logger/1","title":"Nerves.Runtime.Log.SyslogParser.severity_to_logger/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Log.SyslogParser.html#t:facility/0","title":"Nerves.Runtime.Log.SyslogParser.facility/0","type":"type"},{"doc":"","ref":"Nerves.Runtime.Log.SyslogParser.html#t:severity/0","title":"Nerves.Runtime.Log.SyslogParser.severity/0","type":"type"},{"doc":"This GenServer routes syslog messages from C-based applications and libraries through the Elixir Logger for collection.","ref":"Nerves.Runtime.Log.SyslogTailer.html","title":"Nerves.Runtime.Log.SyslogTailer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Nerves.Runtime.Log.SyslogTailer.html#child_spec/1","title":"Nerves.Runtime.Log.SyslogTailer.child_spec/1","type":"function"},{"doc":"Start the local syslog GenServer.","ref":"Nerves.Runtime.Log.SyslogTailer.html#start_link/1","title":"Nerves.Runtime.Log.SyslogTailer.start_link/1","type":"function"},{"doc":"nerves_runtime nerves_runtime is a core component of Nerves. It contains applications and libraries that are expected to be useful on all Nerves devices. Here are its features: Generic system and filesystem initialization (suitable for use with shoehorn) Introspection of Nerves system, firmware, and deployment metadata Device reboot and shutdown A small Linux kernel uevent application for capturing hardware change events and more Device serial numbers The following sections describe the features in more detail. For more information, see the hex docs.","ref":"readme.html","title":"nerves_runtime","type":"extras"},{"doc":"nerves_runtime provides an OTP application (nerves_runtime) that can initialize the system when it is started. For this to be useful, nerves_runtime must be started before other OTP applications, since most will assume that the system is already initialized before they start. To set up nerves_runtime to work with shoehorn, you will need to do the following: Include shoehorn in mix.exs Include shoehorn in your rel/config.exs Ensure that :nerves_runtime is at the beginning of the init: list in your config/config.exs: config :shoehorn, overlay_path: &quot;&quot;, init: [:nerves_runtime, :other_app1, :other_app2], app: :your_app Kernel Modules nerves_runtime will attempt to auto-load kernel modules by calling modprobe using the modalias supplied by the device&#39;s uevent message. You can disable this feature by configuring autoload: false in your application configuration: config :nerves_runtime, :kernel, autoload_modules: false nerves_runtime can optionally report device insertions and removals through SystemRegistry. This is currently the default, but you can disable it via configuration: config :nerves_runtime, :kernel, use_system_registry: false","ref":"readme.html#system-initialization","title":"nerves_runtime - System Initialization","type":"extras"},{"doc":"Nerves systems generally ship with one or more application filesystem partitions. These are used for persisting data that is expected to live between firmware updates. The root filesystem cannot be used since it is mounted as read-only by default. nerves_runtime takes an unforgiving approach to managing the application partition: if it can&#39;t be mounted as read-write, it gets re-formatted. While filesystem corruption should be a rare event, even with unexpected loss of power, Nerves devices may not always be accessible for manual recovery. This default behavior provides a basic recoverability guarantee. To verify that this recovery works, Nerves systems usually leave the application filesystems uninitialized so that the format operation happens on the first boot. This means that the first boot takes slightly longer than subsequent boots. Note that a common implementation of &quot;reset to factory defaults&quot; is to purposely corrupt the application partition and reboot. nerves_runtime uses firmware metadata to determine how to mount and initialize the application partition. The following variables are important: [partition].nerves_fw_application_part0_devpath - the path to the application partition (e.g. /dev/mmcblk0p3) [partition].nerves_fw_application_part0_fstype - the type of filesystem (e.g. ext4) [partition].nerves_fw_application_part0_target - where the partition should be mounted (e.g. /root or /mnt/appdata)","ref":"readme.html#filesystem-initialization","title":"nerves_runtime - Filesystem Initialization","type":"extras"},{"doc":"All official Nerves systems maintain a list of key-value pairs for tracking various information about the system. This information is not intended to be written frequently. To get this information, you can call one of the following: Nerves.Runtime.KV.get_all_active/0 - return all key-value pairs associated with the active firmware. Nerves.Runtime.KV.get_all/0 - return all key-value pairs, including those from the inactive firmware, if any. Nerves.Runtime.KV.get_active/1 - look up the value of a key associated with the active firmware. Nerves.Runtime.KV.get/1 - look up the value of a key, including those from the inactive firmware, if any. Global Nerves metadata includes the following: KeyBuild Environment VariableExample ValueDescription nerves_fw_activeN/A&quot;a&quot;This key holds the prefix that identifies the active firmware metadata. In this example, all keys starting with &quot;a.&quot; hold information about the running firmware. nerves_fw_devpathNERVES_FW_DEVPATH&quot;/dev/mmcblk0&quot;This is the primary storage device for the firmware. nerves_serial_numberN/A&quot;12345abc&quot;This is a text serial number. See Serial numbers for details. nerves_fw_validatedN/A0Set to &quot;1&quot; to indicate that the currently running firmware is valid. (Only supported on some platforms) nerves_fw_autovalidateN/A1Set to &quot;1&quot; to indicate that firmware updates are valid without any additional checks. (Only supported on some platforms) Firmware-specific Nerves metadata includes the following: KeyExample ValueDescription nerves_fw_application_part0_devpath&quot;/dev/mmcblk0p3&quot;The block device that contains the application partition nerves_fw_application_part0_fstype&quot;ext4&quot;The application partition&#39;s filesystem type nerves_fw_application_part0_target&quot;/root&quot;Where to mount the application partition nerves_fw_architecture&quot;arm&quot;The processor architecture (Not currently used) nerves_fw_author&quot;John Doe&quot;The person or company that created this firmware nerves_fw_description&quot;Stuff&quot;A description of the project nerves_fw_platform&quot;rpi3&quot;A name to identify the board that this runs on. It can be checked in the fwup.conf before performing an upgrade. nerves_fw_product&quot;My Product&quot;A product name that may show up in a firmware selection list, for example nerves_fw_version&quot;1.0.0&quot;The project&#39;s version nerves_fw_vcs_identifier&quot;bdeead38...&quot;A git SHA or other identifier (optional) nerves_fw_misc&quot;anything...&quot;Any application info that doesn&#39;t fit in another field (optional) Note that the keys are stored in the environment block prefixed by the firmware slot for which they pertain. For example, a.nerves_fw_description is the description for the firmware in the &quot;A&quot; slot. Several of the keys can be set in the mix.exs file of your main Nerves project. This is the preferred way to set them because it requires the least amount of effort. Assuming that your fwup.conf respects the fwup variable names listed in the table, the keys can also be overridden by setting environment variables at build time. Depending on your project, you may prefer to set them using a customized fwup.conf configuration file instead. The fwup -m value shows the key that you&#39;ll see if you run fwup -m -i project.fw to extract the firmware metadata from the .fw file. Key in Nerves.RuntimeKey in mix.exsBuild Environment VariableKey in fwup -m nerves_fw_application_part0_devpathN/ANERVES_FW_APPLICATION_PART0_DEVPATHN/A nerves_fw_application_part0_fstypeN/ANERVES_FW_APPLICATION_PART0_FSTYPEN/A nerves_fw_application_part0_targetN/ANERVES_FW_APPLICATION_PART0_TARGETN/A nerves_fw_architectureN/ANERVES_FW_ARCHITECTUREmeta-architecture nerves_fw_author:authorNERVES_FW_AUTHORmeta-author nerves_fw_description:descriptionNERVES_FW_DESCRIPTIONmeta-description nerves_fw_platformN/ANERVES_FW_PLATFORMmeta-platform nerves_fw_product:nameNERVES_FW_PRODUCTmeta-product nerves_fw_version:versionNERVES_FW_VERSIONmeta-version nerves_fw_vcs_identifierN/ANERVES_FW_VCS_IDENTIFIERmeta-vcs-identifier nerves_fw_miscN/ANERVES_FW_MISCmeta-misc","ref":"readme.html#nerves-system-and-firmware-metadata","title":"nerves_runtime - Nerves System and Firmware Metadata","type":"extras"},{"doc":"Rebooting, powering-off, and halting a device work by signaling to erlinit an intention to shutdown and then exiting the Erlang VM by calling :init.stop/0. The Nerves.Runtime.reboot/0 and related utilities are helper methods for this. Once they return, the Erlang VM will likely only be available momentarily before shutdown. If the OTP applications cannot be stopped within a timeout as specified in the erlinit.config, erlinit will ungracefully terminate the Erlang VM.","ref":"readme.html#device-reboot-and-shutdown","title":"nerves_runtime - Device Reboot and Shutdown","type":"extras"},{"doc":"If you&#39;d like to go back to the previous version of firmware running on a device, you can do that if the Nerves system supports it. At the IEx prompt, run: iex&gt; Nerves.Runtime.revert Running this command manually is useful in development. Production use requires more work to protect against faulty upgrades. Assisted firmware validation and automatic revert Nerves firmware updates protect against update corruption and powerloss midway into the update procedure. However, what happens if the firmware update contains bad code that hangs the device or breaks something important like networking? Some Nerves systems support tentative runs of new firmware and if something goes wrong, they&#39;ll revert back. At a high level, this involves some additional code from the developer that knows what constitutes &quot;working&quot;. This could be &quot;is it possible to connect to the firmware update server within 5 minutes of boot?&quot; Here&#39;s the process: New firmware is installed in the normal manner. The Nerves.Runtime.KV variable, nerves_fw_validated is set to 0. The system reboots like normal. The device starts a five minute reboot timer (your code needs to do this) The application attempts to make a connection to the firmware update server. On a good connection, the application sets nerves_fw_validated to 1 and cancels the reboot timer. On error, the reboot timer failing, or a hardware watchdog timeout, the system reboots. The bootloader reverts to the previous firmware. To use this feature, the nerves_fw_autovalidate variable must be set to 0. This can be done at device provisioning time (like when the serial number is set) or inside a custom fwup.conf. Best effort automatic revert Unfortunately, the bootloader for platforms like the Raspberry Pi makes it difficult to implement the above mechanism. The following strategy cannot protect against kernel and early boot issues, but it can still provide value: Upgrade firmware the normal way. Record that the next boot will be the first one in the application data partition. On the reboot, if this is the first one, record that the boot happened and revert the firmware with reboot: false. If this is not the first boot, carry on. When you&#39;re happy with the new firmware, revert the firmware again with reboot: false. I.e., revert the revert. It is critical that revert is only called once. To make this handle hangs, you&#39;ll want to enable a hardware watchdog.","ref":"readme.html#reverting-firmware","title":"nerves_runtime - Reverting firmware","type":"extras"},{"doc":"Operating system-level messages from /dev/log and /proc/kmsg, forwarding them to Logger with an appropriate level to match the syslog priority parsed out of the message.","ref":"readme.html#operating-system-log-collection","title":"nerves_runtime - Operating system log collection","type":"extras"},{"doc":"nerves_runtimereceives and processes UEvents from the Linux kernel. The processed events&#39; data is stored in the SystemRegistry. So you need to obtain a current SystemRegistry map before querying the data. E.g.: sr = SystemRegistry.match(:_) Accessing uevent data nerves_runtime stores all device data categorized by subsystem under [:state, &quot;subsystems&quot;]: This map uses the subsystem name as key. It&#39;s value is a list of device paths. The list of currently known subsystems can be obtained using: iex&gt; Map.keys(sr[:state][&quot;subsystems&quot;]) [&quot;mdio_bus&quot;, &quot;remoteproc&quot;, &quot;regulator&quot;, &quot;iio&quot;, &quot;mem&quot;, &quot;soc&quot;, &quot;queues&quot;, &quot;scsi_host&quot;, &quot;clocksource&quot;, &quot;mmc&quot;, &quot;scsi_device&quot;, &quot;mmc_host&quot;, &quot;i2c&quot;, &quot;bsg&quot;, &quot;dma&quot;, &quot;workqueue&quot;, &quot;misc&quot;, &quot;platform&quot;, &quot;leds&quot;, &quot;spi_master&quot;, &quot;gpio&quot;, &quot;scsi&quot;, &quot;vc&quot;, &quot;usb&quot;, &quot;vtconsole&quot;, &quot;watchdog&quot;, &quot;scsi_disk&quot;, &quot;uio&quot;, &quot;bdi&quot;, &quot;hidg&quot;, &quot;udc&quot;, &quot;mbox&quot;, &quot;cpu&quot;, &quot;nvmem&quot;, &quot;net&quot;, &quot;spi&quot;, &quot;clockevents&quot;, &quot;block&quot;, &quot;mmc_rpmb&quot;, &quot;tty&quot;, &quot;i2c-dev&quot;, &quot;spidev&quot;, &quot;pwm&quot;] The list of devices paths for a specific subsystem can be obtained as follows: iex&gt; sr[:state][&quot;subsystems&quot;][&quot;mem&quot;] [ [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;random&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;null&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;urandom&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;full&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;kmsg&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;zero&quot;], [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;mem&quot;] ] WARNING: Compared to the original device paths used by Linux the device path lists contain an additional :state prefix. This allows for a direct usage as keypath into SystemRegistry to access their properties. To access the properties of one of the devices above simply use it&#39;s device path with get_in on SystemRegistry: iex&gt; get_in(sr, [:state, &quot;devices&quot;, &quot;virtual&quot;, &quot;mem&quot;, &quot;zero&quot;]) %{ &quot;devmode&quot; =&gt; &quot;0666&quot;, &quot;devname&quot; =&gt; &quot;zero&quot;, &quot;major&quot; =&gt; &quot;1&quot;, &quot;minor&quot; =&gt; &quot;5&quot;, &quot;subsystem&quot; =&gt; &quot;mem&quot; } WARNING: Please note that the returned map might contain non-binary values for non-leaf devices! iex&gt; get_in(sr, [:state, &quot;devices&quot;, &quot;platform&quot;, &quot;ocp&quot;, &quot;481d8000.mmc&quot;, &quot;mmc_host&quot;, &quot;mmc1&quot;, &quot;mmc1:0001&quot;, &quot;block&quot;, &quot;mmcblk1&quot;]) %{ &quot;devname&quot; =&gt; &quot;mmcblk1&quot;, &quot;devtype&quot; =&gt; &quot;disk&quot;, &quot;major&quot; =&gt; &quot;179&quot;, &quot;minor&quot; =&gt; &quot;8&quot;, &quot;mmcblk1boot0&quot; =&gt; %{ &quot;devname&quot; =&gt; &quot;mmcblk1boot0&quot;, &quot;devtype&quot; =&gt; &quot;disk&quot;, &quot;major&quot; =&gt; &quot;179&quot;, &quot;minor&quot; =&gt; &quot;16&quot;, &quot;subsystem&quot; =&gt; &quot;block&quot; }, &quot;mmcblk1boot1&quot; =&gt; %{ &quot;devname&quot; =&gt; &quot;mmcblk1boot1&quot;, &quot;devtype&quot; =&gt; &quot;disk&quot;, &quot;major&quot; =&gt; &quot;179&quot;, &quot;minor&quot; =&gt; &quot;24&quot;, &quot;subsystem&quot; =&gt; &quot;block&quot; }, &quot;subsystem&quot; =&gt; &quot;block&quot; } The non-binary values are actually the child devices of the device accessed. If you only need the actual device properties you need to filter out non-binary elements. iex&gt; get_in(sr, [:state, &quot;devices&quot;, &quot;platform&quot;, &quot;ocp&quot;, &quot;481d8000.mmc&quot;, &quot;mmc_host&quot;, &quot;mmc1&quot;, &quot;mmc1:0001&quot;, &quot;block&quot;, &quot;mmcblk1&quot;]) |&gt; Enum.filter(fn {key, value} -&gt; is_binary(value) end) |&gt; Map.new() %{ &quot;devname&quot; =&gt; &quot;mmcblk1&quot;, &quot;devtype&quot; =&gt; &quot;disk&quot;, &quot;major&quot; =&gt; &quot;179&quot;, &quot;minor&quot; =&gt; &quot;8&quot;, &quot;subsystem&quot; =&gt; &quot;block&quot; }","ref":"readme.html#uevent-udev-events","title":"nerves_runtime - uevent/udev events","type":"extras"},{"doc":"Finding the serial number of a device is both hardware specific and influenced by you and your organization&#39;s choices for assigning them (or not). Programs should call Nerves.Runtime.serial_number/0 to get the serial number. Nerves systems all come with some default way of getting a serial number for a device. This strategy will likely work for a while, but may not meet your needs when it comes to production. Nerves uses boardid to read serial numbers and it can be customized via its /etc/boardid.config file. See boardid for the mechanisms available. If none of boardid&#39;s mechanisms work for you, please consider filing an issue or making a PR, since our history has been that organizations tend to use similar mechanisms and it&#39;s likely someone else will use it too. As a word of caution, many Nerves users write serial numbers in the U-Boot environment block under the key nerves_serial_number. This is supported and documentation exists for it in many places. While it&#39;s very convenient, it has drawbacks - like it&#39;s easily modified. It&#39;s definitely not the only mechanism. The boardid.config file supports trying multiple ways of getting a serial number to handle hardware changing over the course of development. See embedded-elixir for how to assign serial numbers to devices using the U-Boot environment block way.","ref":"readme.html#serial-numbers","title":"nerves_runtime - Serial numbers","type":"extras"},{"doc":"Applications that depend on nerves_runtime for accessing provisioning information from the Nerves.Runtime.KV can mock the contents with the included Nerves.Runtime.KV.Mock module through the Application config: config :nerves_runtime, Nerves.Runtime.KV.Mock, %{&quot;key&quot; =&gt; &quot;value&quot;} You can also create your own module based on the Nerves.Runtime.KV behavior and set it to be used in the Application config. In most situations, the provided Nerves.Runtime.KV.Mock should be sufficient, though this would be helpful in cases where you might need to generate the initial state at runtime instead: defmodule MyApp.KV.Mock do @behaviour Nerves.Runtime.KV @impl true def init(_opts) do # initial state %{ &quot;howdy&quot; =&gt; &quot;partner&quot;, &quot;dynamic&quot; =&gt; some_runtime_calc_function() } end @impl true def put(_map), do: :ok end # Then in config.exs config :nerves_runtime, :modules, [ {Nerves.Runtime.KV, MyApp.KV.Mock} ]","ref":"readme.html#using-nerves_runtime-in-tests","title":"nerves_runtime - Using nerves_runtime in tests","type":"extras"}]